%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Converted_JT_Counter, Aborted_Conversion_Counter] = Convert_RBE2SEQ_To_PL(Fastener_Index, Layer)

global ErrCode;

global DB_MPC;
global AT_MPC;

global DB_FASTENERS;

global Load_RBE3_minimum_indep_nodes;

% Инициализация счетчиков
Converted_JT_Counter = 0;
Aborted_Conversion_Counter = 0;

% Проверка исходной присоединенной топологии на центрованность
[Test_Result, Center_Node_ID] = Plate_RBE2_Seq_Centered_Test(Fastener_Index, Layer);

if (ErrCode < 0)
    return;
end

% Если присоединенная топология не центрованная, то отменяем конвертацию
if (Test_Result ~= 1)
    Aborted_Conversion_Counter = 1;
    return;
end

% Поиск RBE3, служащих для раздачи нагрузки
Excluded_MPCs = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID;
Load_RBE3_list = Get_MPCs_From_Nodes(Center_Node_ID, Excluded_MPCs);

% Проверка RBE3, служащих для раздачи нагрузки
if (~isempty(Load_RBE3_list))
    
    Check_Flag = 0;
    
    for i=1:numel(Load_RBE3_list)
        if (strcmp(DB_MPC{AT_MPC(Load_RBE3_list(i))}.type, 'RBE3'))
            if (DB_MPC{AT_MPC(Load_RBE3_list(i))}.dep_grid ~= Center_Node_ID)
                if (size(DB_MPC{AT_MPC(Load_RBE3_list(i))}.ind_data,1) >= Load_RBE3_minimum_indep_nodes)
                    Check_Flag = 1;
                end
            end
        end
    end
    
    if (Check_Flag == 0)
        fprintf (1, '\nОшибка функции Convert_RBE2SEQ_To_PL: не пройден тест RBE3, служащих для раздачи нагрузки.\n');
        fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
        ErrCode = -1;
        return;
    end
    
end

% Удаление RBE2
MPC_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID;

Append_To_Output(PCL_MPC_Delete(MPC_list));
DB_MPC_Delete(MPC_list);

if (ErrCode < 0)
    return;
end

% Ассоциирование элементов с узлом болта
Element_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
Node_list = Center_Node_ID;
Target_Node_list = DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer);

Append_To_Output(PCL_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list));
DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list);

if (ErrCode < 0)
    return;
end

% Ассоциирование RBE3, служащих для раздачи нагрузки, с узлом болта
if (~isempty(Load_RBE3_list))
    
    Old_node = Center_Node_ID;
    New_node = DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer);
    
    for i=1:numel(Load_RBE3_list)
        
        MPC_ID = Load_RBE3_list(i);
        Ind_Data = DB_MPC{AT_MPC(MPC_ID)}.ind_data;
        Dep_Node = DB_MPC{AT_MPC(MPC_ID)}.dep_grid;
        Dep_DOFs = DB_MPC{AT_MPC(MPC_ID)}.dep_DOF;
        
        for j=1:size(Ind_Data,1)
            if (Ind_Data(j,2) == Old_node)
                Ind_Data(j,2) = New_node;
                break;
            end
        end

        Append_To_Output(PCL_MPC_Modify_RBE3(MPC_ID, Ind_Data, Dep_Node, Dep_DOFs));
        DB_MPC_Modify_RBE3(MPC_ID, Ind_Data, Dep_Node, Dep_DOFs);

        if (ErrCode < 0)
            return;
        end
        
    end
    
end

% Удаление узла
Node_list = Center_Node_ID;

Append_To_Output(PCL_Node_Delete(Node_list));
DB_Node_Delete(Node_list);

if (ErrCode < 0)
    return;
end

% Внесение изменений в базу данных крепежа
DB_FASTENERS{Fastener_Index}.Joint_topology{Layer} = 'plate';
DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID = [];

% Обновление счетчика
Converted_JT_Counter = 1;
